#include "Globals.h"
#include "Problem.h"



int main(int argc, char * argv[])
{
    //char filename[100];
    string instance;
    string solution;
    bool room_check;

    if (argc<3)
    {
        cout<<"Usage: checksln [instance_filename] [solution_filename] [check_rooms]"<<endl;
        cout<<"check rooms: default 0 = no, 1 = yes"<<endl;
        cout<<"Press return to continue"<<endl;
        char key;
        cin.get(key);
        exit(0);
    }
    instance = argv[1];
    solution = argv[2];

    if (argc>=4 && atoi(argv[3])==1)
        room_check=true;
    else
        room_check=false;

    Problem p;
    p.read_instance(instance);
    p.process_data();


    cout<<"n_lcts: "<<p.n_lcts<<" n_stds: "<<p.n_stds<<" n_tchs: "<<p.n_tchs<<" n_rms: "<<p.n_rms<<endl;

    //    for (map<string, course>::iterator pt=p.elective_courses.begin(); pt!=p.elective_courses.end();pt++)
    //    {
    //        if (pt->second.students.size()==0)
    //                cerr<<instance<<" "<<pt->first<<" "<<pt->second.students.size()<<endl;
    //    }
    //     exit(0);



    Solution s(&p);

    // if needed for debug write a random solution to rnd.sln
    if (argc==5 && atoi(argv[4])==1)
        s.random_sln();

    //At this point we can read the solution file
    s.read_sln(solution);

    cout<<"Read from solution file: "<<endl;
    for (int l=0; l<p.n_lcts; l++)
    {
        cout<<l<<": ";
        cout<<s.tt_electives[l].first<<" ";
        cout<<s.tt_electives[l].second<<endl;
    }


    s.state=2;
    s.check_state_sln(room_check);
    cout<<"---------------------------------------------------------"<<endl<<endl;

    if (s.state==2)
    {
        s.evaluate();
        cout<<"FEASIBLE ";
        cout<<"distance_feasibility: "<<s.distance_feasibility;
        cout<<" soft cost: "<<s.cost<<endl;
    }
    else if (s.state==1)
    {
        s.evaluate();
        cout<<"VALID ";
        cout<<"distance_feasibility: "<<s.distance_feasibility;
        cout<<" soft cost: "<<s.cost<<endl;
    }
    else
        cout<<"NOT_VALID"<<endl;





    return 1;
}


